Code coverage report for lib/http-proxy.js

# All files / lib http-proxy.js

83.33% Statements 5/6
100% Branches 0/0
0% Functions 0/1
83.33% Lines 5/6

Press n or j to go to the next uncovered block, b, p or k for the previous block.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    1x

    1x
    1x
    1x

    1x

      // Use explicit /index.js to help browserify negociation in require '/lib/http-proxy' (!)
    var ProxyServer = require('./http-proxy/index.js').Server;

    /**
     * Creates the proxy server.
     *
     * Examples:
     *
     *    httpProxy.createProxyServer({ .. }, 8000)
     *    // => '{ web: [Function], ws: [Function] ... }'
     *
     * @param {Object} Options Config object passed to the proxy
     *
     * @return {Object} Proxy Proxy object with handlers for `ws` and `web` requests
     *
     * @api public
     */

    function createProxyServer(options) {
      /*
       *  `options` is needed and it must have the following layout:
       *
       *  {
       *    target : <url string to be parsed with the url module>
       *    forward: <url string to be parsed with the url module>
       *    agent  : <object to be passed to http(s).request>
       *    ssl    : <object to be passed to https.createServer()>
       *    ws     : <true/false, if you want to proxy websockets>
       *    xfwd   : <true/false, adds x-forward headers>
       *    secure : <true/false, verify SSL certificate>
       *    toProxy: <true/false, explicitly specify if we are proxying to another proxy>
       *    prependPath: <true/false, Default: true - specify whether you want to prepend the target's path to the proxy path>
       *    ignorePath: <true/false, Default: false - specify whether you want to ignore the proxy path of the incoming request>
       *    localAddress : <Local interface string to bind for outgoing connections>
       *    changeOrigin: <true/false, Default: false - changes the origin of the host header to the target URL>
       *    preserveHeaderKeyCase: <true/false, Default: false - specify whether you want to keep letter case of response header key >
       *    auth   : Basic authentication i.e. 'user:password' to compute an Authorization header.
       *    hostRewrite: rewrites the location hostname on (301/302/307/308) redirects, Default: null.
       *    autoRewrite: rewrites the location host/port on (301/302/307/308) redirects based on requested host/port. Default: false.
       *    protocolRewrite: rewrites the location protocol on (301/302/307/308) redirects to 'http' or 'https'. Default: null.
       *  }
       *
       *  NOTE: `options.ws` and `options.ssl` are optional.
       *    `options.target and `options.forward` cannot be
       *    both missing
       *  }
       */

      return new ProxyServer(options);
    }

    ProxyServer.createProxyServer = createProxyServer;
    ProxyServer.createServer      = createProxyServer;
    ProxyServer.createProxy       = createProxyServer;

    /**
     * Export the proxy "Server" as the main export.
     */
    module.exports = ProxyServer;